'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _Path = require('path');

var _Path2 = _interopRequireWildcard(_Path);

var _readFileSync = require('fs');

var _merge = require('lodash.merge');

var _merge2 = _interopRequireWildcard(_merge);

var _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not = require('ramda');

var _Debug = require('debug');

var _Debug2 = _interopRequireWildcard(_Debug);

var _Jade = require('jade');

var _Jade2 = _interopRequireWildcard(_Jade);

exports['default'] = create;

var read = _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.partialRight(_readFileSync.readFileSync, 'utf8');
var path = _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.partial(_Path2['default'].join, __dirname);
path.template = _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.partial(path, '../templates');
var log = _Debug2['default']('webpack-plugin-bootstrap');

var defaultConfig = {
  meta: {
    charset: 'UTF-8',
    viewport: 'width=device-width, initial-scale=1, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no',
    'apple-mobile-web-app-capable': 'yes',
    'mobile-web-app-capable': 'yes'
  },
  output: {
    fileName: 'index.html'
  },
  compile: {
    pretty: true,
    doctype: 'html'
  }
};

// http://regexr.com/3aomt
var fileExtRegEx = /\.([^.?]+)(?:\?.*)*$/;

function create() {
  var customConfig = arguments[0] === undefined ? {} : arguments[0];

  var config = _merge2['default']({}, defaultConfig, customConfig);
  log('config', config);

  return { apply: apply };

  function apply(compiler) {
    compiler.plugin('emit', function (c, cb) {
      var stats = c.getStats().toJson();
      var publicPath = getPublicPath(c);
      var hashQuery = '?' + stats.hash;

      /* TODO: This pipeline is brittle. It will throw an error if any given
      asset is not a valid file name; specifically any string without an
      extension will break this pipeline. To fix this we should use a Maybe
      Type to branch on the match logic. */

      var getPublicAssets = _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.compose(
      /* nth(1) because match returns the whole matching regex as index 0
      with matching groups as added indexes thereafter. */
      _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.groupBy(_$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.compose(_$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.nth(1), _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.match(fileExtRegEx))), _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.map(_$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.compose(_$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.concat(_$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.__, hashQuery), _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.concat(publicPath))), _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.filter(_$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.compose(_$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.not, _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.match(/\.map$/))), _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.flatten, _$tap$groupBy$nth$match$partial$partialRight$flatten$concat$values$mapObj$map$$$$filter$not.values);

      //log('compilation', Object.keys(c))
      //log('options', Object.keys(c.options))
      //log('stats', Object.keys(stats))
      //log('options.output', c.options.output)
      //log('options.devServer', c.options.devServer)
      //log('stats.assetsByChunkName', stats.assetsByChunkName)
      //log('stats.assets', stats.assets)
      log('publicPath', publicPath);

      try {
        var assetTypesAssetPaths = getPublicAssets(stats.assetsByChunkName);
      } catch (e) {
        throw new Error('Failed to process public assets: ' + e.message);
      }

      log('assetTypesAssetPaths', assetTypesAssetPaths);

      /* If using hot-enabled webpack-dev-server then add its necessary runtime script
      to jsAssets so that it is automatically included in our final html. */

      if (c.options.devServer && c.options.devServer.hot) {
        assetTypesAssetPaths.js = assetTypesAssetPaths.js || [];
        assetTypesAssetPaths.js.push('/webpack-dev-server.js');
      }

      /* Resolve template locals. */

      var locals = _merge2['default']({
        assetTypesAssetPaths: assetTypesAssetPaths,
        title: 'App',
        attributes: {
          html: {},
          head: {},
          body: {}
        },
        headers: {
          mobile: true,
          utf8: true
        },
        react: {
          mainGlobalIdentifier: 'Main',
          autoRender: true
          // + Dynamically Resolved Fields.
        },
        mainElement: {
          id: 'main'
        }
      }, config);

      locals.mainQuerySelector = locals.mainElement ? '#' + locals.mainElement.id : 'body';

      /* Generate HTML contents. */

      if (config.templateExtension) {
        var fileName = config.templateExtension;
        var basedir = _Path2['default'].dirname(config.templateExtension);
        var templateSource = read(config.templateExtension);
        var extendsJadeCode = _Path2['default'].relative(basedir, path.template('default.jade'));
        templateSource = 'extends ' + extendsJadeCode + '\n\n' + templateSource;
      } else {
        var fileName = path.template('./default.jade');
        var templateSource = read(fileName);
      }

      config.compile.filename = fileName;
      var template = _Jade2['default'].compile(templateSource, config.compile);
      var html = template(locals);
      log('html', html);

      /* Add HTML asset to build. */

      c.assets[config.output.fileName] = {
        source: function source() {
          return html;
        },
        size: function size() {
          return html.length;
        }
      };

      cb();
    });
  }
}

function getPublicPath(compilation) {
  var options = compilation.options;
  var devServer = options.devServer;

  if (devServer.publicPath) {
    return devServer.publicPath;
  }var publicPath = options.publicPath;

  if (publicPath) {
    return publicPath;
  }return '/';
}
module.exports = exports['default'];